#include <string>

#include "color.h"
#include "elements.h"
#include "ui.h"
#include "uielements.h"
#include "utils.h"

ConsoleElement::ConsoleElement(kek::UIValue x, kek::UIValue y, kek::UIValue w, kek::UIValue h)
	: kek::RectangleElement(x, y, w, h) {
	color = kek::Colors::BLACK;

	this->textElement = new kek::TextElement(x, y);
	addChild(textElement);

	kek::TextElement *text = new kek::TextElement(uiPx(0), uiPh(1));
	text->textBounds = kek::TextBounds::LINE;
	text->origin = kek::Origin::BOTTOM_LEFT;
	text->setText("user@cringe-studios.com $ ");
	addChild(text);

	this->textFieldElement = new kek::TextFieldElement(uiPx(text->getBounds().w), uiPh(1), uiPw(1) - uiPx(text->getBounds().w));
	textFieldElement->origin = kek::Origin::BOTTOM_LEFT;
	textFieldElement->color = kek::Colors::BLACK;
	textFieldElement->focusColor = kek::Colors::BLACK;
	textFieldElement->cursor->color = kek::Colors::WHITE;
	textFieldElement->textElement->color = kek::Colors::WHITE;
	addChild(textFieldElement);

	textFieldElement->onSubmit = kek::SubmitCallback([](std::string text, void *data) {
		ConsoleElement *_this = (ConsoleElement *) data;
		_this->onCommand(CommandEvent{text});
	},
		this);
}

ConsoleElement::~ConsoleElement() {
	delete textElement;
}

void ConsoleElement::setText(std::string text) {
	textElement->setText(text);
}
